import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class robot_sm_n3 {
    boolean check(String s, int k) {
        if (s.length() < k + 1) {
            return false;
        }
        for (int i = 0; i < s.length() - k; i++) {
            if (s.charAt(i) != s.charAt(i + k)) {
                return false;
            }
        }
        return true;
    }

    void solve() throws IOException {
        int k = nextInt();
        String s = br.readLine();
        long answer = 0;
        for (int from = 0; from < s.length(); from++) {
            for (int to = from + 1; to <= s.length(); to++) {
                if (check(s.substring(from, to), k)) {
                    answer++;
                }
            }
        }
        out.println(answer);
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    void run() throws IOException {
        br = new BufferedReader(new FileReader("robot.in"));
        out = new PrintWriter("robot.out");
        solve();
        out.close();
    }

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new robot_sm_n3().run();
    }
}
