#include <iostream>
#include <stdio.h>

using namespace std;

int fst[100100];
int nxt[200100];
int end[200100];
int bad[200100];
int edges = 0;

void addEdge(int u, int v)
{
	nxt[edges] = fst[u];
	end[edges] = v;
	fst[u] = edges++;
}

int main()
{
	freopen("tournament.in", "r", stdin);
	freopen("tournament.out", "w", stdout);
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		fst[i] = -1;

	for (int i = 0, a, b; i < n; i++)
	{
		scanf("%d%d", &a, &b);
		--a, --b;
		addEdge(a, b);
		addEdge(b, a);
	}	

	int k;
	scanf("%d", &k);
	int kk = k;
	int *answer = new int[k];
	for (int i = 0; k > 0 && i < n; i++)
	{
		if (bad[i]) continue;
		answer[--k] = i;
		for (int j = fst[i]; j != -1; j = nxt[j])
			bad[end[j]] = true;
	}

	if (k > 0)
		puts("0");
	else
	{	
		for (int i = 0; i < kk; i++)
		{
			if (i > 0) printf(" ");
			printf("%d", answer[i] + 1);
		}
	}	
	return 0;
}