#pragma comment(linker,"/STACK:64000000")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <map>
#include <set>
#include <ctime>
#include <algorithm>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

#define WR printf
#define RE scanf
#define PB push_back
#define SE second
#define FI first

#define FOR(i,k,n) for(int i=(k); i<=(n); i++)
#define DFOR(i,k,n) for(int i=(k); i>=(n); i--)
#define SZ(a) (int)((a).size())
#define FA(i,v) FOR(i,0,SZ(v)-1)
#define RFA(i,v) DFOR(i,SZ(v)-1,0)
#define CLR(a) memset(a, 0, sizeof(a))

#define LL long long
#define VI  vector<int>
#define PAR pair<int ,int>
#define o_O 1000000000

void __never(int a){printf("\nOPS %d", a);}
#define ass(s) {if (!(s)) {__never(__LINE__);cout.flush();cerr.flush();abort();}}

int n, k;
bool M[5000][5000];
bool F[5000];
int ans[10000], ans_sz=0;

void dfs( int v, int deep=0 )
{
	F[v] = true;
	if (deep&1) ans[ans_sz++] = v;
	FOR(a,1,n+n)
		if (M[v][a] && !F[a])
			dfs( a, deep+1 );

}

void sol()
{
	FOR(a,1,n+n) if (!F[a])
		dfs(a);

	if (ans_sz < k) WR("0");
	else FOR(a,0,k-1) WR("%d ", ans[a]);
}

int main()
{
	//freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);
	freopen("tournament.in","r",stdin);
	freopen("tournament.out","w",stdout);

	RE("%d", &n); n/=2;
	FOR(a,1,n+n)
	{
		int x, y;
		RE("%d%d", &x, &y);
		M[x][y] = true;
		M[y][x] = true;
	}
	RE("%d", &k);

	sol();
	return 0;
}
