#include <iostream>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define TASK "expedition"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

typedef long long LL;
typedef long double ldb;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <bool> vb;
typedef vector <vb> vvb;

const int INF = (1 << 30) - 1;
const ldb EPS = 1e-9;
const ldb PI = fabs(atan2(0.0, 0.0));

int n;
int c[300100];
void load()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d", &c[i]);
}

void solve()
{
	vi answer;
	int pos = 0;
	while (pos != n - 1)
	{
		answer.pb(pos);
		int nxt = 0;
		for (int j = pos + 1; nxt == 0 && j < n; j++)
		{
			if (c[j] == c[pos]) nxt = j;
		}
		if (nxt == 0)
		{
			puts("0");
			return;
		}
		pos = nxt;
	}

	printf("%d\n", answer.size());
	for (int i = 0; i < (int)answer.size(); i++)
	{
		if (i > 0) printf(" ");
		printf("%d", answer[i] + 1);
	}
}

int main()
{
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
	load();
	solve();
	return 0;
}
