//#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <sstream>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <cstdlib>
#include <cstdio>
#include <iterator>
#include <functional>
#include <bitset>
#define mp make_pair
#define pb push_back

#ifdef LOCAL
#define eprintf(...) fprintf(stderr,__VA_ARGS__)
#else
#define eprintf(...)
#endif

#define TIMESTAMP(x) eprintf("["#x"] Time : %.3lf s.\n", clock()*1.0/CLOCKS_PER_SEC)

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

using namespace std;

#define TASKNAME "expedition"

typedef long long ll;
typedef long double ld;


int n;
int a[310000];
int prev[310000];
vector<int> answer;

map<int,int> last;

int main(){
  freopen(TASKNAME".in","r",stdin);
  freopen(TASKNAME".out","w",stdout);

  scanf("%d",&n);	

  for (int i = 0; i < n; i++)
  	scanf("%d",&a[i]);

  for (int i = 0; i < n; i++){
  	if (last.count(a[i]))
  		prev[i] = last[a[i]];
  	else
  		prev[i] = n;
  	last[a[i]] = i;
  }

  int ans = 0;
  int cur = n - 1;
  int need = n - 1;

  for (int i = n - 1; i >= 0; i--){
  	if (i < cur) ans++, answer.pb(need+1),cur = need;
  	if (i < need) {
  		printf("0\n");
  		return 0;
  	}                 
  	need = min(need, prev[i]);
  }

  printf("%d\n",ans);      
  reverse(answer.begin(),answer.end());
  for (int i = 0; i < ans; i++)
  	printf("%d%c",answer[i]," \n"[i==n0]);
  TIMESTAMP(end);
  return 0;
}
