//N * N
#include <cassert>
#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

const int N = (int) 2534 * 4 + 1;
int n, x[N][2], y[N][2], ans[N][N], ansx[N], ansy[N];
vector<int> allx, ally;

int main() {
	freopen("flashmob.in", "r", stdin);
	freopen("flashmob.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		for (int t = 0; t < 2; ++t) {
			scanf("%d%d", &x[i][t], &y[i][t]);
			for (int delta = 0; delta <= 1; ++delta) {
				allx.push_back(x[i][t] + delta);
				ally.push_back(y[i][t] + delta);
			}
		}
		sort(x[i], x[i] + 2);
		sort(y[i], y[i] + 2);
	}
	sort(allx.begin(), allx.end());
	allx.resize(unique(allx.begin(), allx.end()) - allx.begin());
	sort(ally.begin(), ally.end());
	ally.resize(unique(ally.begin(), ally.end()) - ally.begin());
	for (int i = 0; i < n; ++i) {
		for (int t = 0; t < 2; ++t) {
			x[i][t] = lower_bound(allx.begin(), allx.end(), x[i][t]) - allx.begin();
			y[i][t] = lower_bound(ally.begin(), ally.end(), y[i][t]) - ally.begin();
		}
		bool ok = false;
		for (int dx = x[i][0]; dx <= x[i][1]; ++dx)
			for (int dy = y[i][0]; dy <= y[i][1]; ++dy)
				if (ans[dx][dy] == 0) {
					ans[dx][dy] = i + 1;
					ansx[i] = dx;
					ansy[i] = dy;
					ok = true;
				}
		if (!ok) {
			printf("0\n");
			return 0;
		}
	}
	printf("%d\n", n);
	for (int i = 0; i < n; ++i)
		printf("%d %d\n", allx[ansx[i]], ally[ansy[i]]);
	return 0;
}
