#pragma comment(linker,"/STACK:64000000")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <map>
#include <set>
#include <ctime>
#include <algorithm>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

#define WR printf
#define RE scanf
#define PB push_back
#define SE second
#define FI first

#define FOR(i,k,n) for(int i=(k); i<=(n); i++)
#define DFOR(i,k,n) for(int i=(k); i>=(n); i--)
#define SZ(a) (int)((a).size())
#define FA(i,v) FOR(i,0,SZ(v)-1)
#define RFA(i,v) DFOR(i,SZ(v)-1,0)
#define CLR(a) memset(a, 0, sizeof(a))

#define LL long long
#define VI  vector<int>
#define PAR pair<int ,int>
#define o_O 1000000000

void __never(int a){printf("\nOPS %d", a);}
#define ass(s) {if (!(s)) {__never(__LINE__);cout.flush();cerr.flush();abort();}}

struct T
{
	int x, y;
	T( int _x=0, int _y=0 )
	{
		x = _x;
		y = _y;
	}
};

bool operator== ( const T & A, const T & B )
{
	return A.x==B.x && A.y==B.y;
}

struct HELEM
{
	T pos;
	HELEM * nxt;
};

struct HTABLE
{
	HELEM * hTable[1100000];
	int sz;
	HELEM H[10000000];
	int key( T pp )
	{
		return ( (pp.x*(o_O+7) + pp.y) & ((1<<20)-1) );
	}
	bool has( T p )
	{
		for (HELEM * h = hTable[key(p)]; h; h = h->nxt)
			if (h->pos == p)
				return true;
		return false;
	}
	void add( T p )
	{
		int k = key( p );
		H[sz].pos = p;
		H[sz].nxt = hTable[k];
		hTable[k] = &H[sz];
		sz++;
	}
} H;

int n;
T p1[100500], p2[100500];
map< int, int > X, Y;
int oldX[100500], oldY[100500];
//int field[5000][5000];
T ans[100500];
set< PAR > was;

void scale_coords()
{
	FOR(a,1,n)
	{
		if (p1[a].x > p2[a].x) swap( p1[a].x, p2[a].x );
		if (p1[a].y > p2[a].y) swap( p1[a].y, p2[a].y );
		X[p1[a].x]=0;
		X[p2[a].x+1]=0;
		Y[p1[a].y]=0;
		Y[p2[a].y+1]=0;
	}

	int ii=0;
	for( map< int, int >::iterator it = X.begin(); it != X.end(); it++ )
	{
		oldX[ii] = it->first;
		it->second = ii++;
	}
	ii=0;
	for( map< int, int >::iterator it = Y.begin(); it != Y.end(); it++ )
	{
		oldY[ii] = it->first;
		it->second = ii++;
	}

	FOR(a,1,n)
	{
		p1[a].x = X[p1[a].x];
		p2[a].x = X[p2[a].x+1]-1;
		p1[a].y = Y[p1[a].y];
		p2[a].y = Y[p2[a].y+1]-1;
	}
}

void sol()
{
	scale_coords();

	FOR(a,1,n)
	{
		bool flag = false;
		FOR(b,p1[a].x,p2[a].x) FOR(c,p1[a].y,p2[a].y)
		{
			bool has = H.has( T(b,c) );
			if (!flag && !has)
			{
				ans[a] =  T( oldX[b], oldY[c] );
				flag = true;
			}
			if (!has) H.add( T(b,c) );
		}
		if (!flag)
		{
			WR("0\n");
			return;
		}
	}

	//DFOR(a,n,1) FOR(b,p1[a].x,p2[a].x) FOR(c,p1[a].y,p2[a].y) field[b][c]=a;

	/*FOR(a,0,5)
	{
		FOR(b,0,5) cout << field[a][b];
		cout << "\n";
	}*/
	
	/*FOR(a,0,SZ(X)) FOR(b,0,SZ(Y)) if (field[a][b]>0)
		if (ans[field[a][b]]==T(0,0))
			ans[field[a][b]] = T( oldX[a], oldY[b] );

	FOR(a,1,n) if (ans[a]==T(0,0))
	{
		WR("0\n");
		return;
	}*/

	WR("%d\n", n);
	FOR(a,1,n) WR("%d %d\n", ans[a].x, ans[a].y);
}

int main()
{
	freopen("flashmob.in","r",stdin);
	freopen("flashmob.out","w",stdout);

	RE("%d", &n);
	FOR(a,1,n) RE("%d%d%d%d", &p1[a].x, &p1[a].y, &p2[a].x, &p2[a].y);

	sol();
	return 0;
}
