{$Q+,R+}

const
    MAX_N = 100000;
var
    n, t, k: longint;
    b, e: array [1..MAX_N] of longint;
    ranges: array [1..MAX_N] of longint;
    c: longint;
    ships, cells: longint;

function addRange(b_, e_: longint): longint;
var
    i: longint;
begin
    inc(c);
    b[c] := b_;
    e[c] := e_;
    for i := b_ to e_ - 1 do begin
        ranges[i] := c;
    end;
    result := c;
end;

function shipsOn(i: longint): longint;
begin
    result := (e[i] - b[i] + 1) div (k + 1);
end;

function cellsOn(i: longint): longint;
begin
    result := (k - (e[i] - b[i] + 1) mod (k + 1)) * shipsOn(i);
end;

var
    q, i, j: longint;
begin
    read(n, t, k);
    addRange(1, n + 1);
    ships := shipsOn(c);
    cells := cellsOn(c);

    if t = ships then begin
        writeln(cells);
    end else begin
        writeln(0);
    end;
    flush(output);

    while t <= ships do begin
        read(q);
        i := ranges[q];
        dec(ships, shipsOn(i));
        dec(cells, cellson(i));
        if q - b[i] < e[i] - q then begin
            j := addRange(b[i], q);
            b[i] := q + 1;
        end else begin
            j := addRange(q + 1, e[i]);
            e[i] := q;
        end;
        inc(ships, shipsOn(i) + shipsOn(j));
        inc(cells, cellsOn(i) + cellsOn(j));

        if ships < t then begin
        	break;
        end;
        write(0, ' ');

        if t = ships then begin
            writeln(cells);
        end else begin
            writeln(0);
        end;
        flush(output);
    end;
    writeln(1);
    flush(output);
end.
