#pragma comment(linker,"/STACK:64000000")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <map>
#include <set>
#include <ctime>
#include <algorithm>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

#define WR printf
#define RE scanf
#define PB push_back
#define SE second
#define FI first

#define FOR(i,k,n) for(int i=(k); i<=(n); i++)
#define DFOR(i,k,n) for(int i=(k); i>=(n); i--)
#define SZ(a) (int)((a).size())
#define FA(i,v) FOR(i,0,SZ(v)-1)
#define RFA(i,v) DFOR(i,SZ(v)-1,0)
#define CLR(a) memset(a, 0, sizeof(a))

#define LL long long
#define VI  vector<int>
#define PAR pair<int ,int>
#define o_O 1000000000

void __never(int a){printf("\nOPS %d", a);}
#define ass(s) {if (!(s)) {__never(__LINE__);cout.flush();cerr.flush();abort();}}

int n, t, k;
set< PAR > Set;
int cur_ships=0, cur_blocked=0;

void sol()
{
	RE("%d%d%d", &n, &t, &k);
	Set.insert( make_pair( n, 1 ) );
	cur_ships = (n+1) / (k+1);
	cur_blocked = cur_ships*( k - n + (k+1)*cur_ships - 1 );

	WR("%d\n", cur_ships==t ? cur_blocked : 0);
	fflush(stdout);

	while(1)
	{
		int pos;
		RE("%d", &pos);
		PAR pp = *Set.lower_bound( make_pair( pos, -1 ) );
		Set.erase(pp);

		int tt = (pp.first-pp.second+2) / (k+1);
		cur_ships -= tt;
		cur_blocked -= tt*( k - (pp.first-pp.second+1) + (k+1)*tt - 1 );
		if (pos > pp.second)
		{
			Set.insert( make_pair( pos-1, pp.second ) );
			int ttt = (pos-pp.second+1) / (k+1);
			cur_ships += ttt;
			cur_blocked += ttt*( k - (pos-pp.second) + (k+1)*ttt - 1 );
		}
		if (pos < pp.first)
		{
			Set.insert( make_pair( pp.first, pos+1 ) );
			int ttt = (pp.first-pos+1) / (k+1);
			cur_ships += ttt;
			cur_blocked += ttt*( k - (pp.first-pos) + (k+1)*ttt - 1 );
		}

		if (cur_ships < t)
		{
			WR("1\n");
			fflush( stdout );
			return;
		}

		WR("0 %d\n", cur_ships==t ? cur_blocked : 0);
		fflush( stdout );
	}
}

int main()
{
	//freopen("input.txt","r",stdin);
	//freopen("output.txt","w",stdout);

	sol();
	return 0;
}
