#include <string>
#include <iostream>
#include <fstream>

using namespace std;

bool robotic(int k, const string& s, int left, int right)
{
    if (right - left <= k)
        return false;
    for (int i = left; i + k < right; i++)
        if (s[i] != s[i + k])
            return false;
    return true;
}

int main()
{
    ifstream in("robot.in");
    ofstream out("robot.out");
    int k;
    string s;
    in >> k >> s;
    int n = s.size();
    long long ans = 0;
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j <= n; j++)
            if (robotic(k, s, i, j))
                ans++;
    out << ans << "\n";
}
