import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class robot_sm {

    void solve() throws IOException {
        int k = nextInt();
        String s = br.readLine();
        long answer = 0;
        int from = 0;
        int to = from + k;
        while (from < s.length()) {
            if (to < s.length() && (to - from < k || s.charAt(to) == s.charAt(to - k))) {
                to++;
            } else {
                if (to - from - k > 0) {
                    answer = answer + (to - from - k);
                }
                from++;
            }
        }
        out.println(answer);
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    void run() throws IOException {
        br = new BufferedReader(new FileReader("robot.in"));
        out = new PrintWriter("robot.out");
        solve();
        out.close();
    }

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new robot_sm().run();
    }
}
