#include <cstdio>
#include <cassert>
#include <cstring>
#include <algorithm>

#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#  define LL "%I64d"
#else
#  define LL "%lld"
#endif

using namespace std;

const int maxN = 1000000;

int n, k;
char s[1 + maxN];

int main () {
  assert (freopen ("robot.in", "r", stdin));
  assert (freopen ("robot.out", "w", stdout));

  assert (scanf ("%d", &k) == 1);
  assert (scanf ("%s", s) == 1);
  n = strlen (s);
  long long ans = 0;
  for (int i = 0, j = 0; i < n; ++i) {
    if (j < i + k) {
      j = i + k;
    }
    for (j = max (j, i + k); j < n; ++j) {
      if (s[j] != s[j - k]) {
        break;
      }
    }
    ans += j - (i + k - 1) - 1;
  }
  printf (LL "\n", ans);

  return 0;
}
