#pragma comment(linker,"/STACK:64000000")
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <sstream>
#include <cmath>
#include <ctime>
#include <memory.h>

#define WR printf
#define RE scanf
#define PB push_back
#define SE second
#define FI first
#define MP make_pair

#define FOR(i,Be,En) for(int (i)=(Be);(i)<=(En);++(i))
#define DFOR(i,Be,En) for(int (i)=(Be);(i)>=(En);--(i))
#define SZ(a) (int)((a).size())
#define FA(i,v) FOR(i,0,SZ(v)-1)
#define RFA(i,v) DFOR(i,SZ(v)-1,0)
#define CLR(a) memset(a,0,sizeof(a))

#define LL  long long
#define VI  vector<int>
#define PAR pair<int ,int> 

using namespace std;
void __never(int a){printf("\nOPS %d", a);}
void __die(int a){printf("%d",(a*a)/(a+a));}
#define ass(s) {if (!(s)) {__never(__LINE__);cout.flush();cerr.flush();__die(0);}}



#define MN 1000500



int n,k;

int graf[MN][2];
int deg[MN];

int bad[MN];

int cur[MN];
int taken;

bool dfs(int shag) {
	if (shag == n+n+1) return false;
	if (bad[shag] == 0) {
		cur[++taken] = shag;
		bad[graf[shag][0]]++;
		bad[graf[shag][1]]++;
		if (taken == k) return true;
		if (dfs(shag+1)) return true;
		bad[graf[shag][0]]--;
		bad[graf[shag][1]]--;
		taken--;
	}
	if (dfs(shag+1)) return true;
	return false;
}
void init()
{
	freopen("tournament.in","r",stdin);
	freopen("tournament.out","w",stdout);
}
void sol(){	
	RE("%d",&n);
	n /= 2;
	FOR(i,1,n+n) deg[i] = 0;
	int a,b;
	FOR(i,1,n+n) {
		RE("%d %d",&a,&b);
		graf[a][deg[a]++] = b;
		graf[b][deg[b]++] = a;
	}
	
	FOR(i,1,n+n) bad[i] = 0;
	RE("%d",&k);
	if (k == 0) return ;
	taken = 0;
	if (dfs(1)) {
		FOR(i,1,k) WR(" %d",cur[i]);
	} else {
		WR("0");
	}
}
int main()
{
	init();
	sol();
	return 0;
}