import java.io.*;
import java.util.*;

public class tournament_pk_greedy {

	void solve() throws IOException {
		int n = nextInt() / 2;
		int[][] e = new int[n * 2][2];
		for (int t = 0; t < 2; t++) {
			for (int i = 0; i < n; i++) {
				int a = nextInt() - 1;
				int b = nextInt() - 1;
				e[a][t] = b;
				e[b][t] = a;
			}
		}

		ArrayList<Integer> ans = new ArrayList<Integer>();
		boolean[] was = new boolean[n * 2];
		for (int i = 0; i < n * 2; i++) {
			if ((!was[e[i][0]]) && (!was[e[i][1]])) {
				was[i] = true;
				ans.add(i);
			}
		}
		
		int t = nextInt();
		if (t > ans.size()) {
			for (int i = 0; i < t; i++) {
				out.print(ans.get(i) + 1);
				if (i < t - 1)
					out.print(' ');
				else
					out.println();
			}
		} else {
			out.println(0);
		}
		
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			br = new BufferedReader(new FileReader(new File("tournament.in")));
			out = new PrintWriter("tournament.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new tournament_pk_greedy().run();
	}

	String nextToken() throws IOException {
		while ((st == null) || !st.hasMoreTokens())
			st = new StringTokenizer(br.readLine());
		return st.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}

	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
}
