{$Q-,R-,O+}

const
	MAXN = 100000;
	MAXSIZE = 300000;
var
	color: array[1..MAXN] of longint;
	left, right, ships, points: array[1..MAXSIZE] of longint;
	cntSegments: longint;
	n, k, t, i, segId: longint;
	shot, sumShips, sumPoints: longint;

function max(a, b : longint) : longint;
begin
	if a > b then begin
		max := a;
	end else begin
		max := b;
	end;
end;
	
procedure add(l, r : longint);
var
	last, i: longint;
begin
	if l > r then begin
		exit;
	end;
	inc(cntSegments);
	for i := l to r do begin
		color[i] := cntSegments;
	end;
	left[cntSegments] := l;
	right[cntSegments] := r;
	ships[cntSegments] := (r - l + 2) div (k + 1);
	last := r - l + 1 - k * ships[cntSegments] - ships[cntSegments] + 1;
	points[cntSegments] := max(0, ships[cntSegments] * (k - last));
	sumShips := sumShips + ships[cntSegments];
	sumPoints := sumPoints + points[cntSegments];
end;

procedure change(segId, l, r: longint);
var
	last: longint;
begin
	left[segId] := l;
	right[segId] := r;
	if l > r then begin
		exit;
	end;
	ships[segId] := (r - l + 2) div (k + 1);
	last := r - l + 1 - k * ships[segId] - ships[segId] + 1;
	points[segId] := max(0, ships[segId] * (k - last));
	sumShips := sumShips + ships[segId];
	sumPoints := sumPoints + points[segId];
end;
	
begin
	readln(n, t, k);

	sumShips := 0;
	sumPoints := 0;
	cntSegments := 0;
	for i := 1 to n do begin
		color[i] := 0;
	end;

	for i := 1 to MAXSIZE do begin
		ships[i] := 0;
		points[i] := 0;
		left[i] := 0;
		right[i] := 0;
	end;

	add(1, n);
	if sumShips > t then begin
		writeln(0);
	end else begin
		writeln(sumPoints);
	end;
	flush(output);
	while true do begin
		readln(shot);
		segId := color[shot];
		sumShips := sumShips - ships[segId];
		sumPoints := sumPoints - points[segId];
		if shot = right[segId] then begin
			change(segId, left[segId], shot - 1);		
		end else if shot = left[segId] then begin
			change(segId, shot + 1, right[segId]);
		end else begin
			add(left[segId], shot - 1);
			add(shot + 1, right[segId]);
		end;
		if sumShips < t then begin
			writeln(1);
			break;
		end;
		if sumShips > t then begin
			writeln(0, ' ', 0);
		end else begin
			writeln(0, ' ', sumPoints);
		end;
		flush(output);
	end;
end.