import java.io.*;
import java.util.*;

public class sea_pk_exp {

	boolean[] bad;
	
	void solve() throws IOException {
		int n = nextInt();
		int t= nextInt();
		int k = nextInt();
		
		boolean[] killed = new boolean[n];
		bad = new boolean[n];
		
		while (true) {
			bad = new boolean[n];
			for (int i = 0; i < n; i++) {
				bad[i] = !killed[i];
			}
			boolean[] current = new boolean[n];
			genAllVariants(n, t, k, 0, killed, current);
			int ans = 0;
			for (int i = 0; i < n; i++) {
				if (bad[i])
					ans++;
			}
			out.println(ans);
			out.flush();
			int x = nextInt() - 1;
			if (bad[x]) {
				out.println(1);
				return;
			} else {
				out.print(0 + " ");
			}
			killed[x] = true;
		}
		
	}

	private void genAllVariants(int n, int t, int k, int c, boolean[] killed, boolean[] current) {
		if (t == 0) {
			for (int i = 0; i < n; i++) {
				bad[i] &= current[i];
			}
			System.err.println(Arrays.toString(current));
			System.err.flush();
			return;
		}
		if (c + k > n)
			return;
		
		boolean can = true;
		for (int i = 0; i < k; i++) {
			can &= !killed[c + i];
		}
		
		if (can) {
			for (int i = 0; i < k; i++) {
				current[c + i] = true;
			}
			genAllVariants(n, t - 1, k, c + k + 1, killed, current);
			for (int i = 0; i < k; i++) {
				current[c + i] = false;
			}
		}
		genAllVariants(n, t, k, c + 1, killed, current);
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			//br = new BufferedReader(new FileReader(new File("sea_pk_exp.in")));
			//out = new PrintWriter("sea_pk_exp.out");
			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new sea_pk_exp().run();
	}

	String nextToken() throws IOException {
		while ((st == null) || !st.hasMoreTokens())
			st = new StringTokenizer(br.readLine());
		return st.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}

	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
}
