import java.util.*;
import java.io.*;

public class casting_sp implements Runnable {
    public static void main(String[] args) {
        new Thread(new casting_sp()).start();
    }

    @Override
    public void run() {
        try {
            br = new BufferedReader(new FileReader("casting.in"));
            out = new PrintWriter("casting.out");
            solve();
            out.close();
        } catch (FileNotFoundException e) {
        	e.printStackTrace();
        }
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof = false;

    String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(nextToken());
    }

    double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    long nextLong() {
        return Long.parseLong(nextToken());
    }

    void solve() {
    	int type = nextInt();
    	int n = nextInt();
    	int a = nextInt();
    	int b = nextInt();
    	int c = nextInt();
    	if (type == 1) {
    		out.println(Math.max(0, a + b + c - 2 * n));
    	} else {
    		out.println(Math.min(a, Math.min(b, c)));
    	}
    }
}
